(* NetParser interface.
	This interface defines the NetParser.T object, used
	to provide network connections between a compilation
	server and multiple interpreter units.
*)

(*
	19/02/97	Created.
*)

INTERFACE NetParser;

IMPORT NetObj, Thread;

IMPORT Code;

(* The T type is the super-type of the compiler objects the compiler will export. *)
TYPE	T = NetObj.T OBJECT
		METHODS
			compile(t : TEXT) : Code.T RAISES {Error, NetObj.Error, Thread.Alerted};
			test() RAISES {NetObj.Error, Thread.Alerted};
		END;

(* The Error exception is the exception that compilation will raise
	if something goes horribly wrong! *)
EXCEPTION Error(TEXT);

(* The name to export compilation servers on: *)
CONST	Name = "Armadillo Compiler";

END NetParser.