(* This is the network object interface between the interpreter and
	the 3D display terminal.
*)

(*	??/??/??	Created
	01/12/96	Added Close method to the network display object
			so that the client can notify the display that
			certain resources may be released.
*)

INTERFACE Display;

(* Networking interface. *)
IMPORT NetObj;
(* Graphics primitives. *)
IMPORT Point3, ColorProp;
(* Others. *)
IMPORT Thread;

CONST DisplayNameHdr = "ARMADILLO DISPLAY:";

EXCEPTION NotOpen;

TYPE	T=NetObj.T OBJECT
	METHODS
		init() : Conn RAISES {NetObj.Error, Thread.Alerted};
	END;

	Conn=NetObj.T OBJECT
	METHODS
		join(pt1, pt2 : Point3.T;
			color : ColorProp.Base := ColorProp.Base{1.0, 1.0, 1.0})
			RAISES {NotOpen, NetObj.Error, Thread.Alerted};
		clear() RAISES {NotOpen, NetObj.Error, Thread.Alerted};
		close() RAISES {NotOpen, NetObj.Error, Thread.Alerted};
	END;

END Display.