(* The Turtle interface defines the base abstract turtle object. *)

(*	01/12/96	Created
	02/12/96	Fiddled with the vector rotation system so that now it
			'soils' the turtle a set number of times before recalculating
			the direction vectors.
	12/12/96	Rotation system now uses CrossProduct to keep the direction
			vectors orthogonal and resizes them to stay of unti length
			after each operation.
	07/03/97	Added the home() method to allow turtles to be sent home!
			Duplicate_pos() method has been modified accordingly.
*)

INTERFACE Turtle;

(* Modules from anim3d for doing transforms and stuff. *)
IMPORT Point3;

	(* All distances etc. are specified as REALs. *)
TYPE	Units = REAL;

	(* The Turtle.T forms the basis for the actual working
		turtles used in the interpreter. *)
	T <: Public;
	Public = OBJECT
		METHODS
			init(pos := Point3.T{0.0, 0.0, 0.0};
				forward := Point3.T{0.0, 1.0, 0.0};
				upward := Point3.T{0.0, 0.0, -1.0}
				) : T;
			forward(dist : Units);
			backward(dist : Units);
			tleft(angle : REAL);
			tright(angle : REAL);
			tup(angle : REAL);
			tdown(angle : REAL);
			rleft(angle : REAL);
			rright(angle : REAL);
			home();

			position() : Point3.T;
			facing_fd() : Point3.T;
			facing_up() : Point3.T;

			duplicate_pos(new : T) : T;

			info() : TEXT;
		END;

END Turtle.
