(* Armadillo 3D Display Program.
	This is the interface defining the 3D display object used
	by the 3D terminal program in the armadillo project.
*)

(*
	25/11/96	Created
	01/12/96	The Close method of the network display object
			is now implemented.
			Also added support for having a monochrome terminal.
*)

INTERFACE Window;

EXCEPTION Failed;
	NetFailed;

TYPE	T <: Public;
	Public = OBJECT
		METHODS

			(* Routine to open the display window and initialise anim3d. *)
			init(name : TEXT; mode : ModeSet) : T
				RAISES {Failed, NetFailed};
			(* Wait for this display object to be killed. *)
			awaitDelete();

			(* Some other methods, e.g. to move the camera, could
				be put in here. *)

		END;

	(* Possible display modes. *)
	Mode = {Solid, Colour};
	ModeSet = SET OF Mode;

END Window.