(* ArmRT interface.
	Defines some standard run-time routines and stuff.
*)

(*
	10/12/96	Created.
	17/12/96	Added some functions for controlling the number of
			threads and function instances in the system.
	24/12/96	Added loader routine and objects for the run-time
			limiting commands in the language.
*)

INTERFACE ArmRT;

(* Interpreter modules. *)
IMPORT Node, Loader;

(* Armacode modules. *)
IMPORT Code;

(* Routine to perform sequential execution of object-code. *)
PROCEDURE Execute(self : Node.T; env : Node.E) RAISES {Node.Abort};

(* Run-time limiting routines. *)

PROCEDURE IncThreadCount(env : Node.E) RAISES {Node.Abort};
PROCEDURE DecThreadCount();

PROCEDURE IncFunCount(env : Node.E) RAISES {Node.Abort};
PROCEDURE DecFunCount();

TYPE	MaxThread <: Node.T;
	MaxFunction <: Node.T;

(* Loader routine for the command objects here defined. *)
PROCEDURE Convert(tree : Code.T) : Node.T RAISES {Loader.Failure};

END ArmRT.