(* Concurrency interface.
	Defines the mutex datatype and the functions used in controlling
	concurrent operation of threads.
*)

(*
	11/01/97	Created.
	13/01/97	MAJOR RE-WRITE.  SEE NODE MODULE.
	03/02/97	Added the Send and Recieve objects, used to send
			and recieve data on ports.
*)

INTERFACE Concurrency;

IMPORT Code;

IMPORT Node, Loader;

TYPE	Mutex <: Node.K;
	MutexT <: Node.TYP;

	(* For condition variables. *)
	Signal <: Node.T;
	Wait <: Node.T;

	(* For ports. *)
	Send <: Node.T;
	Recieve <: Node.T;

	(* For locks. *)
	Lock <: Node.T;

PROCEDURE Convert(tree : Code.T) : Node.T RAISES {Loader.Failure};

PROCEDURE NewMutex() : Node.V;

VAR	MutexType : MutexT;

END Concurrency.