(* Functions interface.
	Defines the function closure datatype and also the
	objects representing the function-related commands.
*)

(*
	16/12/96	Created.
	13/01/97	MAJOR RE-WRITE. SEE NODE MODULE.
*)

INTERFACE Functions;

IMPORT Code;

IMPORT Node, Loader;

TYPE	Closure <: Node.K;
	ClosureT <: Node.TYP;

	FunDef <: Node.T;
	FunDecl <: Node.T;
	FunDeclList <: Node.T;

	FunCall <: Node.T;

PROCEDURE Convert(tree : Code.T) : Node.T RAISES {Loader.Failure};

PROCEDURE NewClosure(base_env : Node.E; code, params, returntype : Node.T) : Node.V;

END Functions.