(* Graphics interface.
	This module provides objects for the graphics commands.
*)

(*
	11/12/96	Created.
	12/12/96	Added the object for the Turtle type.
	10/01/97	Added the Turtle datatype type-code.
	12/01/97	Object for the Colour command added.
	13/01/97	MAJOR RE-WRITE.  SEE NODE MODULE.
*)

INTERFACE Graphics;

(* Armacode modules. *)
IMPORT Code;

(* Interpreter modules. *)
IMPORT Node, Loader;

	(* An instance of the Turtle type. *)
TYPE	Turtle <: Node.K;
	(* Allocator for the Turtle type. *)
	TurtleT <: Node.TYP;

	Forward <: Node.T;
	Backward <: Node.T;
	TLeft <: Node.T;
	TRight <: Node.T;
	TUp <: Node.T;
	TDown <: Node.T;
	RLeft <: Node.T;
	RRight <: Node.T;
	PenUp <: Node.T;
	PenDown <: Node.T;
	TurtleCMD <: Node.T;
	Home <: Node.T;
	Clear <: Node.T;
	ClearAll <: Node.T;
	Attach <: Node.T;
	Colour <: Node.T;

	DisplayID <: Node.T;
	DisplayName <: Node.T;
	IPAddress <: Node.T;

PROCEDURE Convert(tree : Code.T) : Node.T RAISES {Loader.Failure};

PROCEDURE NewTurtle() : Node.V;

VAR	TurtleType : TurtleT;

END Graphics.