(* Loader module.
	This module loads in the parse tree created by the
	compiler and turns it into executable object code.
*)

(*
	10/12/96	Created.
	04/02/97	The Loader.Go function is now, by default,
			silent.  Using the /DEBUG option on the command
			line will produce debug output.
*)

INTERFACE Loader;

(* Armacode library modules. *)
IMPORT Code;

(* Interpreter modules. *)
IMPORT Node;

EXCEPTION	Failure;
		FileFail;
		BadVersion(TEXT);

PROCEDURE Go(file : TEXT; verbose : BOOLEAN := FALSE) : Node.T RAISES {FileFail, BadVersion, Failure};

(* Use this converter for Commands ONLY. *)
PROCEDURE ConvertCommand(tree : Code.T) : Node.T RAISES {Failure};

(* Use this one for everything else. *)
PROCEDURE Convert(tree : Code.T) : Node.T RAISES {Failure};

END Loader.