(* TypeSys interface.
	Deals with the definition of user types.
*)

(*
	19/12/96	Created.
	20/01/97	Added a routine which allows two type-codes to be
			compared to check that they are equivalent.  This is
			done by a specific routine to make type coercions
			possible (see NIL).
	25/01/97	Added infinite-type checking routine.
*)

INTERFACE TypeSys;

IMPORT Code;

IMPORT Node, Loader;

TYPE	TypeDef <: Node.T;
	TypeName <: Node.TYP;
	TypeDecl <: Node.T;

PROCEDURE Convert(tree : Code.T) : Node.T RAISES {Loader.Failure};

(* Routine which returns TRUE if code1 and code2 are equivalent,
	or if code2 may be assigned to variables of type code1. *)
PROCEDURE Equivalent(code1, code2 : Node.TYP; env : Node.E) : BOOLEAN RAISES {Node.Abort};

(* Routine to create new type-codes. *)
PROCEDURE NewTypeCode() : CARDINAL;

END TypeSys.