(* Variables interface.
	This interface defines all objects relating to variable operations.
*)

(*
	11/12/96	Skeleton created.  Only exports
			the basic variable object type.
	12/12/96	Added the "var" block type, allowing creation of
			stack frames containing variables.
	13/12/96	Added the "let" command.  This uses the "set_value"
			method to perform assignments to variables.
	03/01/97	Added an object for the "let" command-syntax that
			assigns a single value to several variables.
*)

INTERFACE Variables;

IMPORT Code;

IMPORT Node, Loader;

TYPE	Variable <: Node.T;

	VarBlk <: Node.T;
	Let <: Node.T;
	LetAll <: Node.T;

	VarDeclList <: Node.TYP;
	VarDecl <: Node.TYP;
	VarNameList <: Node.T;

PROCEDURE Convert(tree : Code.T) : Node.T RAISES {Loader.Failure};

END Variables.